
#include "PrecisionTime.h"

// This sketch can be used to calibrate PrecisionTime on a mega based Arduino
// The calibration is stored in EEPROM and can be used by other programs with PrecisionTime
// It also has a test function to show time
// To set the time use "thhmmss", where t is the letter t and hhmmss is the actual time.
// By HKJ from lygte-info.dk

PrecisionTime precisionTime(PRECISIONTIME_EEPROM_ADDRESS);

PRECISION_TIMER_INTR(precisionTime)

void setup() {
  precisionTime.begin();
  Serial.begin(9600);
  Serial.println("Test precision time");
}

// There is no error checking in this input routine.
byte getNumber() {
  return (Serial.read() - '0') * 10 + (Serial.read() - '0');
}

void setTime() {
  precisionTime.setHour(getNumber());
  precisionTime.setMinute(getNumber());
  precisionTime.setSecond(getNumber());
}


void printLeadingZero2(byte v) {
  if (v < 10) Serial.print('0');
  Serial.print(v);
}

void printLeadingZero3(byte v) {
  if (v < 100) Serial.print('0');
  if (v < 10) Serial.print('0');
  Serial.print(v);
}

void loop() {
  precisionTime.update();

  if (Serial.available() > 0) {
    switch (Serial.read()) {
      case '#': precisionTime.startCalibration(); break;
      case 'm': precisionTime.startMillisCheck(); break;
      case 't': setTime(); break;
    }
  }


  Serial.print(precisionTime.getHour());
  Serial.print(':');
  printLeadingZero2(precisionTime.getMinute());
  Serial.print(':');
  printLeadingZero2(precisionTime.getSecond());
  Serial.println();
  delay(1000);

}
